Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 859)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 861)
@@ -699,155 +671,273 @@
        IMPLICIT NONE
 
-       INTEGER ::  i, i_omp, j, k, tn
-       LOGICAL ::  degraded_l, degraded_s
-       REAL    ::  gu, gv, flux_d, diss_d, u_comp_l, v_comp, w_comp
+       INTEGER ::  i, i_omp, j, k, tn, k_ppp, k_pp, k_mm
+       REAL    ::  gu, gv, flux_d, diss_d, u_comp_l, v_comp, w_comp, div
        REAL, DIMENSION(nzb:nzt+1) ::  flux_t, diss_t, flux_r, diss_r,        &
                                       flux_n, diss_n, u_comp
-                                       
-       degraded_l = .FALSE.
-       degraded_s = .FALSE.
 
        gu = 2.0 * u_gtrans
        gv = 2.0 * v_gtrans
-         
-       IF ( boundary_flags(j,i) /= 0 )  THEN
-!       
-!--      Degrade the order for Dirichlet bc. at the outflow boundary
-         SELECT CASE ( boundary_flags(j,i) )
-         
-            CASE ( 1 )
-               DO  k = nzb_u_inner(j,i)+1, nzt
-                  u_comp(k) = u(k,j,i+1) + u(k,j,i)
-                  flux_r(k) = ( u_comp(k) - gu ) * (                          &
-                              7.0 * ( u(k,j,i+1) + u(k,j,i)   )               &
-                            -       ( u(k,j,i+2) + u(k,j,i-1) ) ) * adv_mom_3
-                  diss_r(k) = - ABS( u_comp(k) - gu ) * (                     &
-                              3.0 * ( u(k,j,i+1) - u(k,j,i)   )               &
-                            -       ( u(k,j,i+2) - u(k,j,i-1) ) ) * adv_mom_3
-              ENDDO
-              
-            CASE ( 2 )
-               DO  k = nzb_u_inner(j,i)+1, nzt
-                  u_comp(k) = u(k,j,i+1) + u(k,j,i)
-                  flux_r(k) = ( u_comp(k) - gu ) * (                          &
-                                u(k,j,i+1) + u(k,j,i) ) * 0.25 
-                  diss_r(k) = diss_2nd( u(k,j,i+1) ,u(k,j,i+1), u(k,j,i),     &
-                                        u(k,j,i-1), u(k,j,i-2), u_comp(k),    &
-                                        0.25, ddx )
-               ENDDO
-               
-            CASE ( 3 )
-               DO  k = nzb_u_inner(j,i)+1, nzt
-                  v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                  flux_n(k) = v_comp * (                                      &
-                              7.0 * ( u(k,j+1,i) + u(k,j,i)   )               &
-                            -       ( u(k,j+2,i) + u(k,j-1,i) ) ) * adv_mom_3
-                  diss_n(k) = - ABS( v_comp ) * (                             &
-                              3.0 * ( u(k,j+1,i) - u(k,j,i)     )             &
-                            -       ( u(k,j+2,i) - u(k,j-1,i) ) ) * adv_mom_3
-               ENDDO
-               
-            CASE ( 4 )
-               DO  k = nzb_u_inner(j,i)+1, nzt
-                  v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                  flux_n(k) = v_comp * ( u(k,j+1,i) + u(k,j,i) ) * 0.25
-                  diss_n(k) = diss_2nd( u(k,j+1,i), u(k,j+1,i), u(k,j,i),     &
-                                        u(k,j-1,i), u(k,j-2,i), v_comp,       &
-                                        0.25, ddy )
-               ENDDO
-               
-            CASE ( 5 )
-               DO  k = nzb_u_inner(j,i)+1, nzt
-!               
-!--               Compute leftside fluxes for the left boundary of PE domain
-                  u_comp(k)     = u(k,j,i) + u(k,j,i-1) - gu
-                  flux_l_u(k,j,tn) = u_comp(k) * ( u(k,j,i) + u(k,j,i-1) ) * 0.25
-                  diss_l_u(k,j,tn) = diss_2nd( u(k,j,i+2), u(k,j,i+1), u(k,j,i), &
-                                            u(k,j,i-1), u(k,j,i-1), u_comp(k),&
-                                            0.25, ddx )
-                 
-                  u_comp(k) = u(k,j,i+1) + u(k,j,i)
-                  flux_r(k) = ( u_comp(k) - gu ) * (                          &
-                              7.0 * ( u(k,j,i+1) + u(k,j,i)   )               &
-                            -       ( u(k,j,i+2) + u(k,j,i-1) ) ) * adv_mom_3
-                  diss_r(k) = - ABS( u_comp(k) -gu ) * (                      &
-                              3.0 * ( u(k,j,i+1) - u(k,j,i)   )               &
-                            -       ( u(k,j,i+2) - u(k,j,i-1) ) ) * adv_mom_3
-               ENDDO
-               degraded_l = .TRUE.
-               
-            CASE ( 7 )
-               DO  k = nzb_u_inner(j,i)+1, nzt                           
-                  v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                  flux_n(k) = v_comp * (                                      &
-                              7.0 * ( u(k,j+1,i) + u(k,j,i)   )               &
-                            -       ( u(k,j+2,i) + u(k,j-1,i) ) ) * adv_mom_3
-                  diss_n(k) = - ABS( v_comp ) * (                             &
-                              3.0 * ( u(k,j+1,i) - u(k,j,i)   )               &
-                            -       ( u(k,j+2,i) - u(k,j-1,i) ) ) * adv_mom_3
-               ENDDO 
-               
-            CASE ( 8 )
-               DO  k = nzb_u_inner(j,i)+1, nzt
-!               
-!--              Compute southside fluxes for the south boundary of PE domain
-                  v_comp      = v(k,j,i) + v(k,j,i-1) - gv
-                  flux_s_u(k,tn) = v_comp * ( u(k,j,i) + u(k,j-1,i) ) * 0.25 
-                  diss_s_u(k,tn) = diss_2nd( u(k,j+2,i), u(k,j+1,i), u(k,j,i),   &
-                                          u(k,j-1,i), u(k,j-1,i), v_comp,     &
-                                          0.25, ddy )
-                                  
-                  v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                  flux_n(k) = v_comp * (                                      &
-                              7.0 * ( u(k,j+1,i) + u(k,j,i)   )               &
-                            -       ( u(k,j+2,i) + u(k,j-1,i) ) ) * adv_mom_3
-                  diss_n(k) = - ABS( v_comp ) * (                             &
-                              3.0 * ( u(k,j+1,i) - u(k,j,i)   )               &
-                            -       ( u(k,j+2,i) - u(k,j-1,i) ) ) * adv_mom_3
-               ENDDO  
-               degraded_s = .TRUE.
-               
-            CASE DEFAULT
-            
-         END SELECT
-!         
-!--      Compute the crosswise 5th order fluxes at the outflow
-         IF ( boundary_flags(j,i) == 1 .OR. boundary_flags(j,i) == 2  .OR.    &
-              boundary_flags(j,i) == 5 )  THEN
-         
-             DO  k = nzb_u_inner(j,i)+1, nzt
-               v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
-               flux_n(k) = v_comp * (                                         &
-                           37.0 * ( u(k,j+1,i) + u(k,j,i)   )                 &
-                         -  8.0 * ( u(k,j+2,i) + u(k,j-1,i) )                 &
-                         +        ( u(k,j+3,i) + u(k,j-2,i) ) ) * adv_mom_5
-               diss_n(k) = - ABS ( v_comp ) * (                               &
-                           10.0 * ( u(k,j+1,i) - u(k,j,i)   )                 &
-                         -  5.0 * ( u(k,j+2,i) - u(k,j-1,i) )                 &
-                         +        ( u(k,j+3,i) - u(k,j-2,i) ) ) * adv_mom_5
-             ENDDO
-             
-         ELSE
-         
-            DO  k = nzb_u_inner(j,i)+1, nzt
-               u_comp(k) = u(k,j,i+1) + u(k,j,i)
-               flux_r(k) = ( u_comp(k) - gu ) * (                             &
-                           37.0 * ( u(k,j,i+1) + u(k,j,i)   )                 &
-                         -  8.0 * ( u(k,j,i+2) + u(k,j,i-1) )                 &
-                         +        ( u(k,j,i+3) + u(k,j,i-2) ) ) * adv_mom_5
-               diss_r(k) = - ABS( u_comp(k) - gu ) * (                        &
-                           10.0 * ( u(k,j,i+1) - u(k,j,i) )                   &
-                         -  5.0 * ( u(k,j,i+2) - u(k,j,i-1) )                 &
-                         +        ( u(k,j,i+3) - u(k,j,i-2) ) ) * adv_mom_5
-            ENDDO
-            
-         ENDIF
-                  
-       ELSE
-!       
-!--       Compute the fifth order fluxes for the interior of PE domain.
-          DO  k = nzb_u_inner(j,i)+1, nzt
-             u_comp(k) = u(k,j,i+1) + u(k,j,i)
-             flux_r(k) = ( u_comp(k) - gu ) * (                               &
+!
+!--    Compute southside fluxes for the respective boundary of PE
+       IF ( j == nys  )  THEN
+       
+          DO  k = nzb+1, nzb_max
+
+             v_comp      = v(k,j,i) + v(k,j,i-1) - gv
+             flux_s_u(k,tn) = v_comp * (                                      &
+                         ( 37.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5 &
+                      +     7.0 * IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3 &
+                      +           IBITS(wall_flags_0(k,j,i),12,1) * adv_mom_1 &
+                         ) *                                                  &
+                                     ( u(k,j,i)   + u(k,j-1,i) )              &
+                  -      (  8.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5 &
+                      +           IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3 &
+                         ) *                                                  &
+                                     ( u(k,j+1,i) + u(k,j-2,i) )              &
+                  +      (        IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5 &
+                         ) *                                                  &
+                                     ( u(k,j+2,i) + u(k,j-3,i) )              &
+                                       )
+
+             diss_s_u(k,tn) = - ABS ( v_comp ) * (                            &
+                         ( 10.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5 &
+                      +     3.0 * IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3 &
+                      +           IBITS(wall_flags_0(k,j,i),12,1) * adv_mom_1 &
+                         ) *                                                  &
+                                     ( u(k,j,i)   - u(k,j-1,i) )              &
+                  -      (  5.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5 &
+                      +           IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3 &
+                         ) *                                                  &
+                                     ( u(k,j+1,i) - u(k,j-2,i) )              &
+                  +      (        IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5 &
+                         ) *                                                  &
+                                     ( u(k,j+2,i) - u(k,j-3,i) )              &
+                                                 )
+
+          ENDDO
+
+          DO  k = nzb_max+1, nzt
+
+             v_comp         = v(k,j,i) + v(k,j,i-1) - gv
+             flux_s_u(k,tn) = v_comp * (                                      &
+                           37.0 * ( u(k,j,i) + u(k,j-1,i)   )                 &
+                         -  8.0 * ( u(k,j+1,i) + u(k,j-2,i) )                 &
+                         +        ( u(k,j+2,i) + u(k,j-3,i) ) ) * adv_mom_5
+             diss_s_u(k,tn) = - ABS(v_comp) * (                               &
+                           10.0 * ( u(k,j,i) - u(k,j-1,i)   )                 &
+                         -  5.0 * ( u(k,j+1,i) - u(k,j-2,i) )                 &
+                         +        ( u(k,j+2,i) - u(k,j-3,i) ) ) * adv_mom_5
+
+          ENDDO
+          
+       ENDIF
+!
+!--    Compute leftside fluxes for the respective boundary of PE
+       IF ( i == i_omp )  THEN
+       
+          DO  k = nzb+1, nzb_max
+
+             u_comp_l         = u(k,j,i) + u(k,j,i-1) - gu
+             flux_l_u(k,j,tn) = u_comp_l * (                                   &
+                          ( 37.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5 &
+                       +     7.0 * IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3 &
+                       +           IBITS(wall_flags_0(k,j,i),9,1)  * adv_mom_1 &
+                          ) *                                                  &
+                                     ( u(k,j,i)   + u(k,j,i-1) )               &
+                   -      (  8.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5 &
+                       +           IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3 &
+                          ) *                                                  &
+                                     ( u(k,j,i+1) + u(k,j,i-2) )               &
+                   +      (        IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5 &
+                          ) *                                                  &
+                                     ( u(k,j,i+2) + u(k,j,i-3) )               &
+                                           )
+
+              diss_l_u(k,j,tn) = - ABS( u_comp_l ) * (                         &
+                          ( 10.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5 &
+                       +     3.0 * IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3 &
+                       +           IBITS(wall_flags_0(k,j,i),9,1)  * adv_mom_1 &
+                          ) *                                                  &
+                                     ( u(k,j,i)   - u(k,j,i-1) )               &
+                   -      (  5.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5 &
+                       +           IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3 &
+                          ) *                                                  &
+                                     ( u(k,j,i+1) - u(k,j,i-2) )               &
+                   +      (        IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5 &
+                          ) *                                                  &
+                                     ( u(k,j,i+2) - u(k,j,i-3) )               &
+                                                     )
+
+          ENDDO
+
+          DO  k = nzb_max+1, nzt
+
+             u_comp_l         = u(k,j,i) + u(k,j,i-1) - gu
+             flux_l_u(k,j,tn) = u_comp_l * (                                   &
+                             37.0 * ( u(k,j,i) + u(k,j,i-1)   )                &
+                           -  8.0 * ( u(k,j,i+1) + u(k,j,i-2) )                &
+                           +        ( u(k,j,i+2) + u(k,j,i-3) ) ) * adv_mom_5
+             diss_l_u(k,j,tn) = - ABS(u_comp_l) * (                            &
+                             10.0 * ( u(k,j,i) - u(k,j,i-1)   )                &
+                           -  5.0 * ( u(k,j,i+1) - u(k,j,i-2) )                &
+                           +        ( u(k,j,i+2) - u(k,j,i-3) ) ) * adv_mom_5
+
+          ENDDO
+          
+       ENDIF
+
+       flux_t(0) = 0.0
+       diss_t(0) = 0.0
+       flux_d    = 0.0
+       diss_d    = 0.0
+!
+!--    Now compute the fluxes tendency terms for the horizontal and
+!--    vertical parts.
+       DO  k = nzb+1, nzb_max
+
+          u_comp(k) = u(k,j,i+1) + u(k,j,i)
+          flux_r(k) = ( u_comp(k) - gu ) * (                                 &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),9,1)  * adv_mom_1    &
+                     ) *                                                     &
+                                 ( u(k,j,i+1) + u(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( u(k,j,i+2) + u(k,j,i-1) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( u(k,j,i+3) + u(k,j,i-2) )                 &
+                                           )
+
+          diss_r(k) = - ABS( u_comp(k) - gu ) * (                            &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),9,1)  * adv_mom_1    &
+                     ) *                                                     &
+                                 ( u(k,j,i+1) - u(k,j,i)  )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),10,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( u(k,j,i+2) - u(k,j,i-1) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),11,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( u(k,j,i+3) - u(k,j,i-2) )                 &
+                                                )
+
+          v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
+          flux_n(k) = v_comp * (                                             &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),12,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( u(k,j+1,i) + u(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( u(k,j+2,i) + u(k,j-1,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( u(k,j+3,i) + u(k,j-2,i) )                 &
+                                           )
+
+          diss_n(k) = - ABS ( v_comp ) * (                                   &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),12,1) * adv_mom_1    &
+                     ) *                                                     &
+                                 ( u(k,j+1,i) - u(k,j,i)  )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),13,1) * adv_mom_3    &
+                     ) *                                                     &
+                                 ( u(k,j+2,i) - u(k,j-1,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),14,1) * adv_mom_5    &
+                     ) *                                                     &
+                                 ( u(k,j+3,i) - u(k,j-2,i) )                 &
+                                                )
+!
+!--       k index has to be modified near bottom and top, else array
+!--       subscripts will be exceeded.
+          k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),17,1)
+          k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),15,1)  )
+          k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),17,1)
+
+          w_comp    = w(k,j,i) + w(k,j,i-1)
+          flux_t(k) = w_comp  * (                                            &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),15,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( u(k+1,j,i)  + u(k,j,i)     )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( u(k_pp,j,i) + u(k-1,j,i)   )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( u(k_ppp,j,i) + u(k_mm,j,i) )                  &
+                                 )
+
+          diss_t(k) = - ABS( w_comp ) * (                                    &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),15,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( u(k+1,j,i)   - u(k,j,i)    )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( u(k_pp,j,i)  - u(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( u(k_ppp,j,i) - u(k_mm,j,i) )                  &
+                                         )
+!
+!--       Calculate the divergence of the velocity field. A respective
+!--       correction is needed to overcome numerical instabilities introduced
+!--       by a not sufficient reduction of divergences near topography. 
+          div = ( ( u_comp(k)   - ( u(k,j,i)   + u(k,j,i-1)   ) ) * ddx      &
+               +  ( v_comp + gv - ( v(k,j,i)   + v(k,j,i-1 )  ) ) * ddy      &
+               +  ( w_comp      - ( w(k-1,j,i) + w(k-1,j,i-1) ) ) * ddzw(k)  &
+                ) * 0.5
+
+          tend(k,j,i) = tend(k,j,i) - (                                       &
+                            ( flux_r(k) + diss_r(k)                           &
+                          -   flux_l_u(k,j,tn) - diss_l_u(k,j,tn) ) * ddx     &
+                          + ( flux_n(k) + diss_n(k)                           &
+                          -   flux_s_u(k,tn) - diss_s_u(k,tn)     ) * ddy     &
+                          + ( flux_t(k) + diss_t(k)                           &
+                          -   flux_d    - diss_d                  ) * ddzw(k) &
+                                       ) + div * u(k,j,i)
+
+           flux_l_u(k,j,tn) = flux_r(k)
+           diss_l_u(k,j,tn) = diss_r(k)
+           flux_s_u(k,tn)   = flux_n(k)
+           diss_s_u(k,tn)   = diss_n(k)
+           flux_d           = flux_t(k)
+           diss_d           = diss_t(k)
+!
+!--        Statistical Evaluation of u'u'. The factor has to be applied for
+!--        right evaluation when gallilei_trans = .T. .
+           sums_us2_ws_l(k,tn) = sums_us2_ws_l(k,tn)                          &
+                              + ( flux_r(k) *                                 &
+                                ( u_comp(k) - 2.0 * hom(k,1,1,0) )            &
+                              / ( u_comp(k) - gu + 1.0E-20      )             &
+                              +   diss_r(k) *                                 &
+                                  ABS( u_comp(k) - 2.0 * hom(k,1,1,0) )       &
+                              / ( ABS( u_comp(k) - gu ) + 1.0E-20 ) )         &
+                              *   weight_substep(intermediate_timestep_count)
+!
+!--        Statistical Evaluation of w'u'.
+           sums_wsus_ws_l(k,tn) = sums_wsus_ws_l(k,tn)                        &
+                              + ( flux_t(k) + diss_t(k) )                     &
+                              *   weight_substep(intermediate_timestep_count)
+       ENDDO
+
+       DO  k = nzb_max+1, nzt
+
+          u_comp(k) = u(k,j,i+1) + u(k,j,i)
+          flux_r(k) = ( u_comp(k) - gu ) * (                                  &
                          37.0 * ( u(k,j,i+1) + u(k,j,i)   )                   &
                        -  8.0 * ( u(k,j,i+2) + u(k,j,i-1) )                   &
@@ -867,48 +957,58 @@
                        -  5.0 * ( u(k,j+2,i) - u(k,j-1,i) )                   &
                        +        ( u(k,j+3,i) - u(k,j-2,i) ) ) * adv_mom_5
-          ENDDO 
-         
-       ENDIF
-!       
-!--    Compute left- and southside fluxes for the respective boundary of PE
-       IF ( j == nys .AND. ( .NOT. degraded_s ) )  THEN
-       
-          DO  k = nzb_u_inner(j,i)+1, nzt
-             v_comp      = v(k,j,i) + v(k,j,i-1) - gv
-             flux_s_u(k,tn) = v_comp * (                                         &
-                           37.0 * ( u(k,j,i) + u(k,j-1,i)   )                 &
-                         -  8.0 * ( u(k,j+1,i) + u(k,j-2,i) )                 &
-                         +        ( u(k,j+2,i) + u(k,j-3,i) ) ) * adv_mom_5
-             diss_s_u(k,tn) = - ABS(v_comp) * (                                  &
-                           10.0 * ( u(k,j,i) - u(k,j-1,i)   )                 &
-                         -  5.0 * ( u(k,j+1,i) - u(k,j-2,i) )                 &
-                         +        ( u(k,j+2,i) - u(k,j-3,i) ) ) * adv_mom_5
-          ENDDO
-          
-       ENDIF
-       
-       IF ( i == i_omp .AND. ( .NOT. degraded_l ) )  THEN
-       
-          DO  k = nzb_u_inner(j,i)+1, nzt
-             u_comp_l      = u(k,j,i)+u(k,j,i-1)-gu
-             flux_l_u(k,j,tn) = u_comp_l * (                                     &
-                             37.0 * ( u(k,j,i) + u(k,j,i-1)   )               &
-                           -  8.0 * ( u(k,j,i+1) + u(k,j,i-2) )               &
-                           +        ( u(k,j,i+2) + u(k,j,i-3) ) ) * adv_mom_5
-             diss_l_u(k,j,tn) = - ABS(u_comp_l) * (                              &
-                             10.0 * ( u(k,j,i) - u(k,j,i-1)   )               &
-                           -  5.0 * ( u(k,j,i+1) - u(k,j,i-2) )               &
-                           +        ( u(k,j,i+2) - u(k,j,i-3) ) ) * adv_mom_5
-          ENDDO
-          
-       ENDIF
-!       
-!--    Now compute the tendency terms for the horizontal parts.
-       DO  k = nzb_u_inner(j,i)+1, nzt                   
+!
+!--       k index has to be modified near bottom and top, else array
+!--       subscripts will be exceeded.
+          k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),17,1)
+          k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),15,1)  )
+          k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),17,1)
+
+          w_comp    = w(k,j,i) + w(k,j,i-1)
+          flux_t(k) = w_comp  * (                                            &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),15,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( u(k+1,j,i)  + u(k,j,i)     )                  &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( u(k_pp,j,i) + u(k-1,j,i)   )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( u(k_ppp,j,i) + u(k_mm,j,i) )                  &
+                                 )
+
+          diss_t(k) = - ABS( w_comp ) * (                                    &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                  +           IBITS(wall_flags_0(k,j,i),15,1) * adv_mom_1    &
+                     ) *                                                     &
+                             ( u(k+1,j,i)   - u(k,j,i)    )                  &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                  +           IBITS(wall_flags_0(k,j,i),16,1) * adv_mom_3    &
+                     ) *                                                     &
+                             ( u(k_pp,j,i)  - u(k-1,j,i)  )                  &
+              +      (        IBITS(wall_flags_0(k,j,i),17,1) * adv_mom_5    &
+                     ) *                                                     &
+                             ( u(k_ppp,j,i) - u(k_mm,j,i) )                  &
+                                         )
+!
+!--       Calculate the divergence of the velocity field. A respective
+!--       correction is needed to overcome numerical instabilities introduced
+!--       by a not sufficient reduction of divergences near topography.
+          div = ( ( u_comp(k)   - ( u(k,j,i)   + u(k,j,i-1)   ) ) * ddx      &
+               +  ( v_comp + gv - ( v(k,j,i)   + v(k,j,i-1 )  ) ) * ddy      &
+               +  ( w_comp      - ( w(k-1,j,i) + w(k-1,j,i-1) ) ) * ddzw(k)  &
+                ) * 0.5
+
           tend(k,j,i) = tend(k,j,i) - (                                       &
                             ( flux_r(k) + diss_r(k)                           &
-                          -   flux_l_u(k,j,tn) - diss_l_u(k,j,tn) ) * ddx           &
+                          -   flux_l_u(k,j,tn) - diss_l_u(k,j,tn) ) * ddx     &
                           + ( flux_n(k) + diss_n(k)                           &
-                          -   flux_s_u(k,tn) - diss_s_u(k,tn)     ) * ddy  )
+                          -   flux_s_u(k,tn) - diss_s_u(k,tn)     ) * ddy     &
+                          + ( flux_t(k) + diss_t(k)                           &
+                          -   flux_d    - diss_d                  ) * ddzw(k) &
+                                       ) + div * u(k,j,i)
 
            flux_l_u(k,j,tn) = flux_r(k)
